//+------------------------------------------------------------------+
//|                                                 VanessaFX EA.mq4 |
//|                      Copyright  2007, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"


extern string    basicheader="== Basic Settings ==";
extern double    TakeProfit=0;
extern double    Stoploss=0;
extern double    Lots=0.1;
extern bool      VanessaFX_Basic_System=false;
extern bool      AO_Exits=true;

extern string    stopheader="== Advanced Stops ==";
extern double    TrailingStop=0;                      // TS distance for following two options
extern bool      UseTrailingStop=false;               // Trailing stop regular
extern bool      UseTrailingStopOnlyProfit=false;     // Trailing stop that only activates when an order is profitting
extern int       breakEvenAtProfit=0;
extern int       breakEvenShift=0;
extern int       SteppingStop=0;

extern string    mischeader="== Misc. Options ==";
extern string    shortName="VanessaFX";
extern int       magicNum=15411178;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
//----
   
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
  {
   Comment ("");
   int allOrders=0, buyOrders=0, sellOrders=0, buyPending=0, sellPending=0;
   checkOrderStatus(allOrders,buyOrders,sellOrders,buyPending,sellPending);
   advancedStopManager(allOrders);

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

   double quickMA0=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,1);
   double slowMA0=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,1);


if (VanessaFX_Basic_System==false)
{
   if (buyOrders == 1)
      if (quickMA0<slowMA0 || AOexitBuy())
         closeBuyOrder();
         
   if (sellOrders == 1)
      if (quickMA0>slowMA0 || AOexitSell())
         closeSellOrder();

   if (buyOrders == 0)
   { 
      if ( (recentMACDcrossBuy() || parabolicBuy()) && recentMAcrossBuy() )
           sendBuyOrder();
   }

   if (sellOrders == 0)
   { 
      if ( (recentMACDcrossSell() || parabolicSell()) && recentMAcrossSell() )
           sendSellOrder();
   }
}




//+------------------------------------------------------------------+


else

{

   if (buyOrders == 1)
      if (quickMA0<slowMA0)
         closeBuyOrder();
         
   if (sellOrders == 1)
      if (quickMA0>slowMA0)
         closeSellOrder();

   if (buyOrders == 0)
   { 
      if (recentMACDcrossBuy() && recentMAcrossBuy())
           sendBuyOrder();
   }

   if (sellOrders == 0)
   { 
      if (recentMACDcrossSell() && recentMAcrossSell())
           sendSellOrder();
   }

}

//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

   return(0);
  }
  
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+
//+------------------------------------------------------------------+

void sendSellOrder() // Standard Version 1.61
   {
      double Stopvalue=0, TPvalue=0;
      if (Stoploss>0)
         {Stopvalue = Ask+Stoploss*Point;}
      if (TakeProfit>0)
         {TPvalue = Bid-TakeProfit*Point;}
         
      int ticket=OrderSend(Symbol(),OP_SELL,Lots,Bid,3,Stopvalue,TPvalue,shortName + " " + Period(),magicNum,0,Red);
      if(ticket>0)
         {if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print(shortName + " SELL order at ",OrderOpenPrice()); }
      else 
         {Print("Error opening SELL order : ",GetLastError());}
   }

//+------------------------------------------------------------------+

void sendBuyOrder() // Standard Version 1.61
   {
     double Stopvalue=0, TPvalue=0;
     if (Stoploss>0)
        {Stopvalue = Bid-Stoploss*Point;}
     if (TakeProfit>0)
        {TPvalue = Ask+TakeProfit*Point;}

     int ticket=OrderSend(Symbol(),OP_BUY,Lots,Ask,3,Stopvalue,TPvalue,shortName + " " + Period(),magicNum,0,Green);
     if(ticket>0)
       {if(OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES)) Print(shortName + " BUY order at ",OrderOpenPrice()); }
     else 
        {Print("Error opening BUY order : ",GetLastError());}
   }
   
//+------------------------------------------------------------------+

void regularTrailingStop() // Standard Version 1.61
{
   int cnt, total = OrdersTotal();
   
   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderType()<=OP_SELL && orderBelongsToMe())
        {if(TrailingStop>0)  
           {if(OrderType()==OP_BUY)
              {if(OrderStopLoss()<Bid-Point*TrailingStop)
                 { OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green); 
                 }}}
            else
              {if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                 { OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red); 
                 }}}}
}

//+------------------------------------------------------------------+

void onlyProfitTrailingStop() // Standard Version 1.61
   {
   
   int cnt, total = OrdersTotal();

   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderType()<=OP_SELL && orderBelongsToMe())
        {if(TrailingStop>0)  
           {if(OrderType()==OP_BUY)
              {if(Bid-OrderOpenPrice()>Point*TrailingStop)
                 {if(OrderStopLoss()<Bid-Point*TrailingStop)
                    { OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*TrailingStop,OrderTakeProfit(),0,Green); 
                        }}}}
            else
              {if((OrderOpenPrice()-Ask)>(Point*TrailingStop))
                 {if((OrderStopLoss()>(Ask+Point*TrailingStop)) || (OrderStopLoss()==0))
                    { OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*TrailingStop,OrderTakeProfit(),0,Red); 
                        }}}}}}
   
//+------------------------------------------------------------------+

void closeSellOrder() // Standard Version 1.61
   {
   int cnt, total = OrdersTotal();

   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()==OP_SELL && orderBelongsToMe())
           {OrderClose(OrderTicket(),OrderLots(),Ask,3,CLR_NONE); 
             }}}

//+------------------------------------------------------------------+

void closeBuyOrder() // Standard Version 1.61
   {
   int cnt, total = OrdersTotal();

   for(cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()==OP_BUY && orderBelongsToMe())
           {OrderClose(OrderTicket(),OrderLots(),Bid,3,CLR_NONE); 
             }}}

//+------------------------------------------------------------------+

void breakEvenManager() // Standard Version 1.61

   {
   
   for(int cnt=0;cnt<OrdersTotal();cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

      if(OrderType()<=OP_SELL && orderBelongsToMe())
        {if(breakEvenAtProfit>0)  
           {if(OrderType()==OP_BUY)
              {if(Bid-OrderOpenPrice()>=Point*breakEvenAtProfit)
                 {if(OrderStopLoss()!=OrderOpenPrice() + breakEvenShift*Point)
                    { OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()+ breakEvenShift*Point,OrderTakeProfit(),0,Green); 
                        }}}}
             else
              {if((OrderOpenPrice()-Ask)>(Point*breakEvenAtProfit))
                 {if(OrderStopLoss()!=OrderOpenPrice() - breakEvenShift*Point)
                    { OrderModify(OrderTicket(),OrderOpenPrice(),OrderOpenPrice()- breakEvenShift*Point,OrderTakeProfit(),0,Red); 
                        }}}}}}
   
//+------------------------------------------------------------------+

 // Standard Version 1.61
void checkOrderStatus(int& allOrders,int& buyOrders,int& sellOrders,int& buyPending, int& sellPending)
{
   for(int cnt=OrdersTotal();cnt>=0;cnt--)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if( orderBelongsToMe() )
        {  
         if (OrderType()==OP_BUY)
            {buyOrders++; allOrders++;}
         else if (OrderType()==OP_SELL)
            {sellOrders++; allOrders++;}
         else if (OrderType()==OP_BUYSTOP || OrderType()==OP_BUYLIMIT)
            {buyPending++; allOrders++;}
         else if (OrderType()==OP_SELLSTOP || OrderType()==OP_SELLLIMIT)
            {sellPending++; allOrders++;}

        }
     }
}

//+------------------------------------------------------------------+

void advancedStopManager(int allOrders) // Standard Version 1.61
{
   if (UseTrailingStopOnlyProfit && UseTrailingStop)
      {Print("Both Trailing Stops are enabled.  Defaulting to Regular TS.");}
    
   if (allOrders >= 1)
   {
      if (SteppingStop>0)
         steppingStopManager();
      if (breakEvenAtProfit>0)
         breakEvenManager();
      if (UseTrailingStop)
          regularTrailingStop();
      else if (UseTrailingStopOnlyProfit)
          onlyProfitTrailingStop();
    }
}

//+------------------------------------------------------------------+

void steppingStopManager() // Standard Version 1.61
{

   int cnt, total = OrdersTotal();
   double stepStopValue;
   
   for(cnt=0;cnt<total;cnt++)
   {
    OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);

    if(OrderType()<=OP_SELL && orderBelongsToMe())
      {if(SteppingStop>0)  
         {if(OrderType()==OP_BUY)
            {if(OrderStopLoss()<Bid-Point*SteppingStop)
              {stepStopValue=0;
                 while (stepStopValue<Bid-Point*SteppingStop)
                     {stepStopValue = stepStopValue+SteppingStop*Point;}
                        OrderModify(OrderTicket(),OrderOpenPrice(),stepStopValue,OrderTakeProfit(),0,Green); 
               }}}
          else
            {if((OrderStopLoss()>(Ask+Point*SteppingStop)) || (OrderStopLoss()==0))
               {stepStopValue=Ask+1000;
                  while (stepStopValue>Ask+Point*SteppingStop)
                      {stepStopValue = stepStopValue-SteppingStop*Point;}
                         OrderModify(OrderTicket(),OrderOpenPrice(),OrderStopLoss()-Point*SteppingStop,OrderTakeProfit(),0,Red); 
               }}}}
}

//+------------------------------------------------------------------+

bool orderBelongsToMe() // Standard Version 1.61
{
if (
    OrderSymbol()==Symbol() && 
    OrderMagicNumber()==magicNum
    )
   return (true);
else
   return (false);
}
//+------------------------------------------------------------------+


//+------------------------------------------------------------------+


//+------------------------------------------------------------------+


bool recentMACDcrossSell()
{

   double macd0=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,0);
   double macd1=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,1);
   double macd2=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,2);
   double macd3=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,3);
   double macd4=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,4);
   double macd5=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,5);
   
   
   double signal0=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,0);
   double signal1=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,1);
   double signal2=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,2);
   double signal3=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,3);
   double signal4=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,4);
   double signal5=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,5);



   if (macd0<signal0 &&
       {
       (macd1<signal1 && macd2>signal2) ||
       (macd2<signal2 && macd3>signal3) ||
       (macd3<signal3 && macd4>signal4) ||
       (macd4<signal4 && macd5>signal5)
       }
       )
       return (true);
   else
      return (false);

}

//+------------------------------------------------------------------+

bool recentMACDcrossBuy()
{
   double macd0=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,0);
   double macd1=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,1);
   double macd2=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,2);
   double macd3=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,3);
   double macd4=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,4);
   double macd5=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,0,5);
   
   
   double signal0=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,0);
   double signal1=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,1);
   double signal2=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,2);
   double signal3=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,3);
   double signal4=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,4);
   double signal5=iCustom(NULL,0,"VanessaFX - MACD with No Histogram",12,26,9,1,5);



   if (macd0>signal0 &&
       {
       (macd1>signal1 && macd2<signal2) ||
       (macd2>signal2 && macd3<signal3) ||
       (macd3>signal3 && macd4<signal4) ||
       (macd4>signal4 && macd5<signal5) 
       }
       )
       return (true);
   else
      return (false);
       

}

//+------------------------------------------------------------------+

bool recentMAcrossBuy()
{

   double quickMA0=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,0);
   double quickMA1=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,1);
   double quickMA2=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,2);
   double quickMA3=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,3);
   double quickMA4=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,4);
   double quickMA5=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,5);

   double slowMA0=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,0);
   double slowMA1=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,1);
   double slowMA2=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,2);
   double slowMA3=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,3);
   double slowMA4=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,4);
   double slowMA5=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,5);



   if (quickMA0>slowMA0 &&
       {
       (quickMA1>slowMA1 && quickMA2<slowMA2) ||
       (quickMA2>slowMA2 && quickMA3<slowMA3) ||
       (quickMA3>slowMA3 && quickMA4<slowMA4) ||
       (quickMA4>slowMA4 && quickMA5<slowMA5) 
       }
       )
       return (true);
   else
      return (false);



}

//+------------------------------------------------------------------+

bool recentMAcrossSell()
{


   double quickMA0=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,0);
   double quickMA1=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,1);
   double quickMA2=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,2);
   double quickMA3=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,3);
   double quickMA4=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,4);
   double quickMA5=iMA(NULL,0,6,0,MODE_EMA,PRICE_CLOSE,5);

   double slowMA0=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,0);
   double slowMA1=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,1);
   double slowMA2=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,2);
   double slowMA3=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,3);
   double slowMA4=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,4);
   double slowMA5=iMA(NULL,0,13,0,MODE_SMA,PRICE_CLOSE,5);






   if (quickMA0<slowMA0 &&
       {
       (quickMA1<slowMA1 && quickMA2>slowMA2) ||
       (quickMA2<slowMA2 && quickMA3>slowMA3) ||
       (quickMA3<slowMA3 && quickMA4>slowMA4) ||
       (quickMA4<slowMA4 && quickMA5>slowMA5)
       }
       )
       return (true);
   else
      return (false);



}

//+------------------------------------------------------------------+

bool parabolicBuy()
{

   double par0=iSAR(NULL,0,0.02,0.2,0);
   double par1=iSAR(NULL,0,0.02,0.2,1);


   if (par0<Low[0] || par1<Low[1])
      return (true);
   else
      return (false);
   
}

//+------------------------------------------------------------------+

bool parabolicSell()
{

   double par0=iSAR(NULL,0,0.02,0.2,0);
   double par1=iSAR(NULL,0,0.02,0.2,1);


   if (par0>High[0] || par1>High[1])
      return (true);
   else
      return (false);

}

//+------------------------------------------------------------------+

bool AOexitBuy()
{

   if (AO_Exits)
   {
   
      double aonum = iAC(NULL, 0, 0);
      double aopast = iAC(NULL, 0, 1);

      if (aonum<0 && aopast<0 && aonum<aopast)
         {Comment ("Buy Order clsoed due to AO"); return (true);}
      else
         return (false);
   }
   else
      return (false);

}


//+------------------------------------------------------------------+

bool AOexitSell()
{

   if (AO_Exits)
   {
   
      double aonum = iAC(NULL, 0, 0);
      double aopast = iAC(NULL, 0, 1);

      if (aonum>0 && aopast>0 && aonum>aopast)
         {Comment ("Sell Order clsoed due to AO"); return (true);}
      else
         return (false);

   }
   else
      return (false);
}

//+------------------------------------------------------------------+

//+------------------------------------------------------------------+

